#!/bin/sh 
# Another awful bourne shell
#
#

if [ "$XPRESSFAX_HOME" = "" ]; then
	XPRESSFAX_HOME=`dirname $0`/..
	if [ "$XPRESSFAX_HOME" = "./.." ]; then
		XPRESSFAX_HOME=`pwd`/..
	fi
fi
# Routine to ask a question with default passed and check for typos
# $?=1 for default response
# $1=question, $2=default, $3=opposite of $2
ask(){
        answer=undefined
        echo -n "$1 [$2]: "
        read answer
        until [ "$answer" = "" -o "$answer" = "$2" -o "$answer" = "$3" ];
        do
           echo "Please type '$2' or '$3'."
           echo -n "$1 [$2]: "
           read answer
        done
        [ "$answer" = "$2" -o "$answer" = "" ]
}

clear
if [ `whoami` != "root" ]; then
	echo "Sorry, only root may run this script."
	exit 1
fi


add_lpd_message(){
echo "
********************************************************************************
********************************************************************************
**                                                                            **
**                         XpressFax Version  1.0.5                           **
**                       Lpd Alias Installation Script                        **
**                                                                            **
********************************************************************************
********************************************************************************

The XpressFax Package allows you to create a lpd entry in /etc/printcap through
which valid faxusers may queue text and postscript files to the fax queue. 	

"
}

clear
if [ "$1" != "notitle" ]; then
	add_lpd_message
	if ask "Would you like to install an lpd filter?" "y" "n"; then
		echo 0
	else
		exit 0
	fi
fi
clear
echo "
********************************************************************************
********************************************************************************
**                                                                            **
**                        XpressFax Version  1.0.5                            **
**                       Lpd Alias Installation Script                        **
**                                                                            **
********************************************************************************
********************************************************************************

Please enter the name of the printer alias you would like to use.   
The default is \"fax\", allowing users to type \"lpr -Pfax -J<phonenumber>\"
to queue text or postscript to the fax queue.

"
ALIAS=""
echo -n "Enter the printer alias name to use [fax]: "
read ALIAS
if [ $ALIAS ]; then
	echo
else
	ALIAS=fax
fi

R=`egrep "^$ALIAS|$ALIAS:" /etc/printcap | wc -l`
if [ $R -eq 0 ]; then
	echo ""
else
	echo "
Sorry, that entry already exists in /etc/printcap.   You'll have to remove it
it by hand and re-run this script ($XPRESSFAX_HOME/install/install_lpd.sh)

Hit any key to exit
"
	read ALIAS
	exit 0
fi

if ask "Is this to be a local (l) or remote (r) printer entry? " "l" "r"; then
mkdir /var/spool/$ALIAS
chown daemon /var/spool/$ALIAS
chgrp daemon /var/spool/$ALIAS

touch /var/spool/$ALIAS/null
chown daemon.daemon /var/spool/$ALIAS/null
chmod 755 /var/spool/$ALIAS/null

touch /var/spool/$ALIAS/lw-log
chown daemon.daemon /var/spool/$ALIAS/lw-log
chmod 755 /var/spool/$ALIAS/lw-log

echo "
$ALIAS|$ALIAS|XpressFax Input Filter:\\
        :lp=/var/spool/$ALIAS/null:sd=/var/spool/$ALIAS:\\
        :if=$XPRESSFAX_HOME/filters/lpd_filter:\\
        :lf=/var/spool/$ALIAS/lw-log:mx#0:sb:" >> /etc/printcap
/usr/etc/lpc restart $ALIAS
exit 0
else

echo -n "Enter the hostname of the machine which has the local entry for $ALIAS: "
read HOST
if [ $HOST ]; then
	echo
else
	echo "
Sorry, you must specify a remote host name.   Aborting printer installation.
Hit return to continue."
	read HOST
	exit 0
fi
mkdir /var/spool/$ALIAS
chown daemon /var/spool/$ALIAS
chgrp daemon /var/spool/$ALIAS

touch /var/spool/$ALIAS/lw-log
chown daemon.daemon /var/spool/$ALIAS/lw-log
chmod 755 /var/spool/$ALIAS/lw-log

echo "
$ALIAS|$ALIAS|Remote XpressFax Input Filter:\\
	:lp=:rm=$HOST:sd=/var/spool/$ALIAS:\\
        :lf=/var/spool/$ALIAS/lw-log:mx#0:sb:" >> /etc/printcap
/usr/etc/lpc restart $ALIAS
fi
